<template lang="pug">
  .counterbar.flex.br3.ba.b--gray.bg-white.pa3
    .counterbar__counter.flex-l.flex-column-l.items-center.br-l.bb.b--gray(ref="counter")
      .flex-auto.f1.b.flex.items-center {{counter}}
      .f5(v-if="title") {{title}}
    .counterbar__bar.ph3(ref="bar" :style="barStyle")
</template>
<script>
import c3 from 'c3'

const BAR_WIDTH = 80

export default {
  props: {
    counter: {
      type: Number,
      required: true
    },
    bars: {
      type: Array,
      required: true,
      validator (val) {
        return Array.isArray(val) && val.every(item => 'label' in item && 'count' in item)
      }
    },
    title: {
      type: String,
      default: ''
    }
  },
  data () {
    return {
      chart: null
    }
  },
  computed: {
    c3Opts () {
      if (this.bars.length === 0 || !this.$refs.bar) {
        return null
      }
      const opt = {
        bindto: this.$refs.bar,
        data: {
          x: 'x',
          columns: [
            ['x', ...this.bars.map(item => this.zhTitle(item.label))],
            ['data', ...this.bars.map(item => item.count)]
          ],
          type: 'bar',
          labels: true
        },
        transition: {
          duration: 100
        },
        bar: {
          width: {
            ratio: 0.5
          }
        },
        axis: {
          x: {
            type: 'category'
          },
          y: {
            show: false
          }
        },
        legend: {
          show: false
        },
        tooltip: {
          show: false
        }
      }
      return opt
    },
    barStyle () {
      if (!this.c3Opts) {
        return {
          maxWidth: '20rem'
        }
      }

      const barLen = this.c3Opts.data.columns[0].length - 1
      return {
        maxWidth: `${barLen * BAR_WIDTH}px`
      }
    }
  },
  watch: {
    c3Opts (opt) {
      if (!opt) {
        return
      }
      if (!this.chart) {
        this.chart = c3.generate(opt)
      } else {
        this.chart.load({
          columns: opt.data.columns
        })
      }

      setTimeout(() => {
        this.chart.resize()
      }, 110)
    }
  },
  mounted () {
    if (this.c3Opts) {
      this.chart = c3.generate(this.c3Opts)
    }
  },
  methods: {
    zhTitle (title) {
      return title.replace(/[a-zA-Z]/g, '').replace(/ +/g, ' ')
    }
  }
}
</script>
<style lang="scss" scoped>
$counterWidth: 12rem;
$widgetHeight: 10rem;

.counterbar {
  &__counter {
    height: $widgetHeight;
    @media screen and (min-width: 60em) {
      width: $counterWidth;
      border-bottom-width: 0;
    }
  }
  &__bar {
    height: $widgetHeight;
    /deep/ {
      .c3-texts text.c3-text {
        transform: translate(0, 22px);
        fill: white !important;
      }
      .c3-axis-x {
        .domain {
          display: none;
        }
        .tick line {
          display: none;
        }
      }
    }
    @media screen and (min-width: 60em) {
      width: calc(100% - #{$counterWidth})
    }
  }
}
</style>
